﻿
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel

Public Module Extensions
    <System.Runtime.CompilerServices.Extension()> _
    Public Sub [Each](Of T)(ByVal items As IEnumerable(Of T), ByVal action As Action(Of T))
        For Each item In items
            action(item)
        Next item
    End Sub

    <System.Runtime.CompilerServices.Extension()> _
    Public Function StripLeft(ByVal value As String, ByVal length As Integer) As String
        Return value.Substring(length, value.Length - length)
    End Function

    <System.Runtime.CompilerServices.Extension()> _
    Public Sub Raise(ByVal eventHandler As PropertyChangedEventHandler, ByVal source As Object, ByVal propertyName As String)
        Dim handlers = eventHandler
        If handlers IsNot Nothing Then
            handlers(source, New PropertyChangedEventArgs(propertyName))
        End If
    End Sub

    <System.Runtime.CompilerServices.Extension()> _
    Public Sub Raise(ByVal eventHandler As EventHandler, ByVal source As Object)
        Dim handlers = eventHandler
        If handlers IsNot Nothing Then
            handlers(source, EventArgs.Empty)
        End If
    End Sub

    <System.Runtime.CompilerServices.Extension()> _
    Public Sub Register(ByVal model As INotifyPropertyChanged, ByVal propertyName As String, ByVal whenChanged As Action)
        AddHandler model.PropertyChanged, Sub(sender, args)
                                              If args.PropertyName = propertyName Then
                                                  whenChanged()
                                              End If
                                          End Sub
    End Sub
End Module