﻿Imports System
Imports System.Dynamic

Public Interface IViewModelResolver
    Function Resolve(ByVal viewModelName As String) As Object
End Interface

Public Class DefaultViewModelResolver
    Implements IViewModelResolver
    Public Function Resolve(ByVal viewModelName As String) As Object Implements IViewModelResolver.Resolve
        Return Nothing
    End Function
End Class

Public Class ViewModelLocator
    Inherits DynamicObject
    Public Sub New()
        Resolver = New DefaultViewModelResolver()
    End Sub

    Public Property Resolver() As IViewModelResolver

    Default Public ReadOnly Property Item(ByVal viewModelName As String) As Object
        Get
            Return Resolver.Resolve(viewModelName)
        End Get
    End Property

    Public Overrides Function TryGetMember(ByVal binder As GetMemberBinder, <System.Runtime.InteropServices.Out()> ByRef result As Object) As Boolean
        result = Me(binder.Name)
        Return True
    End Function
End Class